include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext MonoPattern, ColorPattern
ext VVram_

CharPatternSize equ VramStep*CharHeight
Top equ VramRowSize*0

dseg
Backup:
	defs VVramWidth*VVramHeight
CharRam: public CharRam
    defs CharPatternSize*Char_End

cseg
ColorSource:
defb 64,3 ; Ascii
defb 4,3 ; M
defb 4,2 ; A
defb 4,3 ; Z
defb 4,1 ; Y
defb 1,1 ; Wall
defb 0
InitVram: public InitVram
    mov ax,0004h | int 10h ; Set video mode
    mov ax,0500h | int 10h ; Select active display page

    mov si,MonoPattern
    mov di,CharRam
    mov bx,ColorSource
    do
        mov ch,[bx]
        or ch,ch
    while nz
        inc bx
        mov dl,[bx] | inc bx
        call MakePatternMono
    wend

    mov si,ColorPattern
    mov ch,Char_End-Char_Knife
    call MakePatternColor
ret

MakePatternMono:
;   di: destination
;   si: source
;   dl: color
;   ch: count
    mov dh,dl
    shr dh,1 | shr dh,1 | shr dh,1 | shr dh,1
    do
        mov cl,CharHeight
        do
            push cx
                mov al,[si] | inc si
                mov ch,VramStep
                do
                    xor ah,ah
                    mov cl,8/VramStep
                    do
                        shl ah,1 | shl ah,1
                        shl al,1
                        if c
                            or ah,dl
                        else
                            or ah,dh
                        endif
                        dec cl
                    while nz | wend
                    mov [di],ah | inc di
                    dec ch
                while nz | wend
            pop cx
            dec cl
        while nz | wend
        dec ch
    while nz | wend
ret
MakePatternColor:
;   di: destination
;   si: source
;   ch: count
    do
        mov cl,CharPatternSize
        do
            mov al,[si] | inc si
            mov [di],al | inc di
            dec cl
        while nz | wend
        dec ch
    while nz | wend
ret


; void ClearScreen();
cseg
Clear:
    xor ax,ax 
    do
        mov [bx],ax
        inc bx | inc bx
    wloop
ret
ClearScreen_: public ClearScreen_
    push ax | push bx | push cx
        mov ax,VramSegment | mov es,ax
        xor ax,ax
        mov bx,0
        do
            mov [es:bx],ax
            inc bx | inc bx
            cmp bx,4000h
        while nz | wend
        
		mov bx,Backup
		mov cx,VVramWidth*VVramHeight/2
        call Clear
    pop cx | pop bx | pop ax
ret


; word Put(word vram, byte c);
cseg
Put:
    add ax,CharRam
    mov si,ax
    mov cl,CharHeight/2
    do
        mov ax,[si]
        inc si | inc si
        mov [es:di],ax
        mov ax,[si]
        inc si | inc si
        mov [es:di+2000h],ax
        add di,VramWidth
        dec cl
    while nz | wend
ret
Put_: public Put_
	push ax | push cx | push si | push di
	    mov di,ax
        mov ax,VramSegment | mov es,ax
        mov al,CharPatternSize | mul dl
        call Put
	pop di | pop si | pop cx | pop ax
	add ax,VramStep
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
	push ax | push cx | push dx | push bx | push si | push di
        mov ax,VramSegment | mov es,ax
        mov bx,VVram_
		mov si,Backup
		mov di,Vram+Top
		mov ch,VVramHeight ; vertical count
		do
			mov cl,VVramWidth
			do 
				mov al,[bx] | inc bx
                cmp al,Char_End
                jae VVramToVram_write
				cmp al,[si]
				if ne
                    VVramToVram_write:
					mov [si],al
                    push cx | push si
                        mov ah,CharPatternSize | mul ah
                        call Put
                    pop si | pop cx
                    sub di,VramWidth*CharHeight/2
				endif
				inc di | inc di
				inc si
				dec cl
			while nz | wend
			add di,-VVramWidth*VramStep+VramRowSize
			dec ch
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret
